%bcond_with gtk2
%bcond_with php
%bcond_with guile
%bcond_with ruby

%global SHARP  0
%global ARRRR  0
%global DEVIL  0
%global GTS    0
%global LASI   0
%global OCAML  0
%global QTAPPS 0
%global MING   0

%if %{with php}
%global PHP 1
%else
%global PHP 0
%endif

%if %{with guile}
%global GUILE 1
%else
%global GUILE 0
%endif

%global pluginsver 6
%global php_extdir %(php-config --extension-dir 2>/dev/null || echo %{_libdir}/php4)
%if "%{php_version}" < "5.6"
%global ini_name     %{name}.ini
%else
%global ini_name     40-%{name}.ini
%endif


Summary:		Graph Visualization Tools
Name:			graphviz
Version:		2.50.0
Release:		3%{?dist}
License:		EPL-1.0
URL:			http://www.graphviz.org/
Source0:		https://gitlab.com/%{name}/%{name}/-/archive/%{version}/%{name}-%{version}.tar.bz2
Patch3000:		graphviz-2.49.3-gvpack-neato-static.patch

BuildRequires:		make automake autoconf gcc-g++ bison m4 flex libtool libtool-ltdl-devel
BuildRequires:		zlib-devel libpng-devel libjpeg-devel fontconfig-devel expat-devel tk-devel
BuildRequires:          libXt-devel libXmu-devel libXaw-devel libXext-devel libSM-devel
BuildRequires:		pango-devel gmp-devel gd-devel librsvg2-devel urw-base35-fonts
BuildRequires:		python3-devel java-devel lua-devel perl-devel
BuildRequires:		perl-Carp perl-ExtUtils-Embed perl-generators
BuildRequires:		freetype-devel >= 2
BuildRequires:		tcl-devel >= 8.3
BuildRequires:		cairo-devel >= 1.1.10
BuildRequires:		swig >= 1.3.33

%if %{with gtk2}
BuildRequires:          gtk2-devel
%endif
%if %{GUILE}
BuildRequires:		guile-devel
%endif
%if %{with ruby}
BuildRequires:          ruby-devel
%endif
%if %{PHP}
BuildRequires:		php-devel
%endif
%if %{SHARP}
BuildRequires:		mono-core
%endif
%if %{DEVIL}
BuildRequires:		DevIL-devel
%endif
%if %{ARRRR}
BuildRequires:		R-devel
%endif
%if %{OCAML}
BuildRequires:		ocaml
%endif
%if %{QTAPPS}
BuildRequires:		qt-devel
%endif
%if %{GTS}
BuildRequires:		gts-devel
%endif
%if %{LASI}
BuildRequires:		lasi-devel
%endif

Requires:		urw-base35-fonts
Requires:		xorg-x11-fonts-ISO8859-1-100dpi
Requires(post):		/sbin/ldconfig
Requires(postun):	/sbin/ldconfig


%description
A collection of tools for the manipulation and layout of graphs (as in nodes
and edges, not as in barcharts).


%package devel
Summary:		Development package for graphviz
Requires:               pkgconfig
Requires:		%{name} = %{version}-%{release}
Requires:		%{name}-gd = %{version}-%{release}

%description devel
This package contains development files for graphviz.


%if %{DEVIL}
%package devil
Summary:		Graphviz plugin for renderers based on DevIL
Requires:		%{name} = %{version}-%{release}

%description devil
Graphviz plugin for renderers based on DevIL. (Unless you absolutely have
to use BMP, TIF, or TGA, you are recommended to use the PNG format instead
supported directly by the cairo+pango based renderer in the base graphviz rpm.)
%endif


%package doc
Summary:		PDF and HTML documents for graphviz

%description doc
Provides some additional PDF and HTML documentation for graphviz.


%package gd
Summary:		Graphviz plugin for renderers based on gd
Requires:		%{name} = %{version}-%{release}
Requires(post):		%{_bindir}/dot /sbin/ldconfig
Requires(postun):	%{_bindir}/dot /sbin/ldconfig

%description gd
Graphviz plugin for renderers based on gd.  (Unless you absolutely have to use
GIF, you are recommended to use the PNG format instead because of the better
quality anti-aliased lines provided by the cairo+pango based renderer.)

%if %{with gtk2}
%package gtk2
Summary:		Graphviz plugin for renderers based on gtk2
Requires:		%{name} = %{version}-%{release}
Requires(post):		%{_bindir}/dot /sbin/ldconfig
Requires(postun):	%{_bindir}/dot /sbin/ldconfig

%description gtk2
Graphviz plugin for renderers based on gtk2.
%endif

%package graphs
Summary:		Demo graphs for graphviz

%description graphs
Some demo graphs for graphviz.

%if %{GUILE}
%package guile
Summary:		Guile extension for graphviz
Requires:		%{name} = %{version}-%{release}

%description guile
Guile extension for graphviz.
%endif


%package java
Summary:		Java extension for graphviz
Requires:		%{name} = %{version}-%{release}

%description java
Java extension for graphviz.


%package lua
Summary:		Lua extension for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:               lua

%description lua
Lua extension for graphviz.


%if %{MING}
%package ming
Summary:		Graphviz plugin for flash renderer based on ming
Requires:		%{name} = %{version}-%{release}

%description ming
Graphviz plugin for -Tswf (flash) renderer based on ming.
%endif


%if %{OCAML}
%package ocaml
Summary:		Ocaml extension for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:               ocaml
%description ocaml
Ocaml extension for graphviz.
%endif


%package perl
Summary:		Perl extension for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:		perl-libs

%description perl
Perl extension for graphviz.


%if %{PHP}
%package php
Summary:		PHP extension for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:	        php(zend-abi) = %{?php_zend_api}%{?!php_zend_api:UNDEFINED}
Requires:	        php(api) = %{?php_core_api}%{?!php_core_api:UNDEFINED}

%description php
PHP extension for graphviz.
%endif


%package python3
Summary:		Python 3 extension for graphviz
Requires:		%{name} = %{version}-%{release}
Provides:               python3dist(gv) = %{version}
Provides:               python%{python3_version}dist(gv) = %{version}

%description python3
Python 3 extension for graphviz.


%if %{ARRRR}
%package R
Summary:		R extension for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:               R-core
%description R
R extension for graphviz.
%endif

%if %{with ruby}
%package ruby
Summary:		Ruby extension for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:               ruby
%description ruby
Ruby extension for graphviz.
%endif

%if %{SHARP}
%package sharp
Summary:		C# extension for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:               mono-core
%description sharp
C# extension for graphviz.
%endif


%package tcl
Summary:		Tcl extension & tools for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:               tcl >= 8.3
Requires:               tk

%description tcl
Various tcl packages (extensions) for the graphviz tools.


%prep
%autosetup -p1
find -type f -regex '.*\.\(c\|h\)$' -exec chmod a-x {} ';'


%build
./autogen.sh
sed -i '/JavaVM.framework/!s/JAVA_INCLUDES=/JAVA_INCLUDES=\"_MY_JAVA_INCLUDES_\"/g' configure
sed -i 's|_MY_JAVA_INCLUDES_|-I%{java_home}/include/ -I%{java_home}/include/linux/|g' configure
sed -i 's|expand(|expand(RbConfig::|' config/config_ruby.rb
sed -i 's|sitearchdir|vendorarchdir|' config/config_ruby.rb

%if %{with ruby}
export CPPFLAGS=-I`ruby -e "puts File.join(RbConfig::CONFIG['includedir'], RbConfig::CONFIG['sitearch'])" || echo /dev/null`
%endif

%configure --with-x --disable-static --disable-dependency-tracking \
	--without-mylibgd --with-ipsepcola --with-pangocairo \
	--with-gdk-pixbuf --with-visio --disable-silent-rules --enable-lefty \
%if ! %{LASI}
	--without-lasi \
%endif
%if ! %{GTS}
	--without-gts \
%endif
%if ! %{SHARP}
	--disable-sharp \
%endif
%if ! %{OCAML}
	--disable-ocaml \
%endif
%if ! %{MING}
	--without-ming \
%endif
%if ! %{ARRRR}
	--disable-r \
%endif
%if ! %{DEVIL}
	--without-devil \
%endif
%if ! %{QTAPPS}
	--without-qt \
%endif
%if %{GUILE}
	--enable-guile=yes
%else
	--enable-guile=no
%endif

# delete rpath
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

%make_build CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -fno-strict-overflow %{?FFSTORE}" \
  CXXFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -fno-strict-overflow %{?FFSTORE}"


%install
%make_install docdir=%{buildroot}%{_docdir}/%{name} \
	      pkgconfigdir=%{_libdir}/pkgconfig

find %{buildroot} -type f -name "*.la" -exec rm -f {} ';'

mkdir -p %{buildroot}%{_docdir}/%{name}
mv %{buildroot}%{_datadir}/%{name}/doc/* %{buildroot}%{_docdir}/%{name}

install -m0644 README %{buildroot}%{_docdir}/%{name}


%if %{PHP}
%{__mkdir_p} %{buildroot}%{_sysconfdir}/php.d
%{__cat} << __EOF__ > %{buildroot}%{_sysconfdir}/php.d/%{ini_name}
; Enable %{name} extension module
extension=gv.so
__EOF__
%endif

find %{buildroot}%{_datadir}/%{name}/demo -type f -exec chmod a-x {} ';'

mv %{buildroot}%{_datadir}/%{name}/demo %{buildroot}%{_docdir}/%{name}/

find %{buildroot}%{_docdir}/%{name}/demo -type f -name "*.py" -exec mv {} {}.demo ';'

rm -f %{buildroot}%{_bindir}/dot_builtins


# python 3
install -pD tclpkg/gv/.libs/libgv_python3.so %{buildroot}%{python3_sitearch}/_gv.so
install -p tclpkg/gv/gv.py %{buildroot}%{python3_sitearch}/gv.py

touch %{buildroot}%{_libdir}/graphviz/config%{pluginsver}

if [ "%{_prefix}" != "/usr" ]; then
  cp -ru %{buildroot}/usr/* %{buildroot}%{_prefix}/
  rm -rf %{buildroot}/usr/*
fi


%check
%if %{PHP}
LD_LIBRARY_PATH=%{buildroot}%{_libdir} \
php --no-php-ini \
    --define extension_dir=%{buildroot}%{_libdir}/graphviz/php/ \
    --define extension=libgv_php.so \
    --modules | grep gv
%endif



%post
%{_bindir}/dot -c 2>/dev/null || :


%if %{DEVIL}
%post devil
%{_bindir}/dot -c 2>/dev/null || :

%postun devil
%{_bindir}/dot -c 2>/dev/null || :
%endif

%post gd
%{_bindir}/dot -c 2>/dev/null || :

%postun gd
%{_bindir}/dot -c 2>/dev/null || :

%if %{with gtk2}
%post gtk2
%{_bindir}/dot -c 2>/dev/null || :

%postun gtk2
%{_bindir}/dot -c 2>/dev/null || :
%endif

%if %{MING}
%post ming
%{_bindir}/dot -c 2>/dev/null || :

%postun ming
%{_bindir}/dot -c 2>/dev/null || :
%endif


%files
%doc %{_docdir}/%{name}
%{_bindir}/*
%dir %{_libdir}/graphviz
%{_libdir}/*.so.*
%{_libdir}/graphviz/*.so.*
%{_mandir}/man1/*.1*
%{_mandir}/man7/*.7*
%dir %{_datadir}/graphviz
%exclude %{_docdir}/%{name}/html
%exclude %{_docdir}/%{name}/pdf
%exclude %{_docdir}/%{name}/demo
%{_datadir}/graphviz/lefty
%{_datadir}/graphviz/gvpr
%ghost %{_libdir}/graphviz/config%{pluginsver}

%if %{QTAPPS}
%{_datadir}/graphviz/gvedit
%endif

%exclude %{_libdir}/graphviz/*/*
%exclude %{_libdir}/graphviz/libgvplugin_gd.*
%if %{with gtk2}
%exclude %{_libdir}/graphviz/libgvplugin_gtk.*
%exclude %{_libdir}/graphviz/libgvplugin_gdk.*
%endif
%if %{DEVIL}
%exclude %{_libdir}/graphviz/libgvplugin_devil.*
%endif
%if %{MING}
%exclude %{_libdir}/graphviz/libgvplugin_ming.*
%exclude %{_libdir}/graphviz/*fdb
%endif


%files devel
%{_includedir}/graphviz
%{_libdir}/*.so
%{_libdir}/graphviz/*.so
%{_libdir}/pkgconfig/*.pc
%{_mandir}/man3/*.3.*


%if %{DEVIL}
%files devil
%{_libdir}/graphviz/libgvplugin_devil.so.*
%endif


%files doc
%doc %{_docdir}/%{name}/html
%doc %{_docdir}/%{name}/pdf
%doc %{_docdir}/%{name}/demo


%files gd
%{_libdir}/graphviz/libgvplugin_gd.so.*

%if %{with gtk2}
%files gtk2
%{_libdir}/graphviz/libgvplugin_gtk.so.*
%{_libdir}/graphviz/libgvplugin_gdk.so.*
%endif

%files graphs
%dir %{_datadir}/graphviz
%{_datadir}/graphviz/graphs


%if %{GUILE}
%files guile
%{_libdir}/graphviz/guile/
%{_mandir}/man3/gv.3guile*
%endif


%files java
%{_libdir}/graphviz/java/
%{_mandir}/man3/gv.3java*


%files lua
%{_libdir}/graphviz/lua/
%{_libdir}/lua*/*
%{_mandir}/man3/gv.3lua*


%if %{MING}
%files ming
%{_libdir}/graphviz/libgvplugin_ming.so.*
%{_libdir}/graphviz/*fdb
%endif


%if %{OCAML}
%files ocaml
%{_libdir}/graphviz/ocaml/
%{_mandir}/man3/gv.3ocaml*
%endif

%files perl
%{_libdir}/graphviz/perl/
%{_libdir}/perl*/*
%{_mandir}/man3/gv.3perl*


%if %{PHP}
%files php
%config(noreplace) %{_sysconfdir}/php.d/%{ini_name}
%{_libdir}/graphviz/php/
%{php_extdir}/gv.so
%{_datadir}/php*/*
%{_mandir}/man3/gv.3php*
%endif


%files python3
%{python3_sitearch}/*
%{_mandir}/man3/gv.3python*


%if %{ARRRR}
%files R
%{_libdir}/graphviz/R/
%{_mandir}/man3/gv.3r.*
%endif

%if %{with ruby}
%files ruby
%{_libdir}/graphviz/ruby/
%{_libdir}/*ruby*/*
%{_mandir}/man3/gv.3ruby*
%endif


%if %{SHARP}
%files sharp
%{_libdir}/graphviz/sharp/
%{_mandir}/man3/gv.3sharp*
%endif


%files tcl
%{_libdir}/graphviz/tcl/
%{_libdir}/tcl*/*
%{_mandir}/man3/*.3tcl*

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.50.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.50.0-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Nov 14 2022 rockerzhu <rockerzhu@tencent.com> - 2.50.0-1
- Initail build
